'''hfb solver for a pure pairing interaction
with an arbitrary single-particle potential.'''
import sys
from numpy import *
from td_utilities import *
from hamiltonian import Gamma_Delta,mk_esp,get_N


  
N= get_N(); Nx=N/2
print 'Number of orbitals', N
esp = mk_esp()
pnice(esp,'esp')
Nop = esp*0.0
for i in range(N):
  Nop[i,i] = 1.0             #operator for particle number
U,V = read_uv(N,'uv.4b.gs.dat')
check_unitarity(U,V)
rho,kappa = rho_kappa(U,V)
gamma,delta = Gamma_Delta(rho,kappa)
print '  i    <N>    <hsp> '
Nave=F00(rho,Nop)
e0,v1,vpair =H00(rho,kappa,gamma,delta,esp)
e_ave=e0+v1+vpair
e_start=e_ave
ss=' %i %8.5f %8.5f ' % (0,Nave,e_ave)
print ss
u2=U*1.0; v2=V*1.0
eta=0.1
Nsteps = int(sys.argv[1])
for i in range(1,Nsteps+1) :
  hsp=esp + gamma
  h20 = H20(u2,v2,hsp,delta)
  N20 = F20(u2,v2,Nop)
  t1 = trace(dot(adjoint(h20),N20))
  t2 = trace(dot(adjoint(N20),N20))
  c=t1/t2
  h20c = h20- c*N20
#  h20c = h20
  Z=-eta*h20c
  u2,v2=Zc(Z,u2,v2)
  rho,kappa = rho_kappa(u2,v2)
  gamma,delta = Gamma_Delta(rho,kappa)
  e0,v1,vpair = H00(rho,kappa,gamma,delta,esp)
  Nave=F00(rho,Nop)
  e_ave=e0+v1+vpair
  ss=' %i %8.5f %8.5f ' % (i,Nave,e_ave)
  print ss
print 'Delta(E)', e_ave-e_start
write_uv(u2,v2)