''' tdhfb by the H20 integration
 all Hamiltonian-dependent info is in the last import
Version z: the input uv.dat is transformed by a complex
Z transformation before starting the time evolution.
'''
import sys
from numpy import *
import numpy.linalg as la
from td_utilities import *
from hamiltonian import mk_esp,v_me,Gamma_Delta,get_N

if len(sys.argv) < 5:
  print 'wf_file, dt, Nt, Zc_file  on command line'
  raise Exception
Nt = int(sys.argv[3])
dt = float(sys.argv[2])
print 'dt,Nt', dt,Nt
zc_file = sys.argv[4]
N = get_N()
esp = mk_esp()
Nop = esp*0.0
for i in range(N):
  Nop[i,i] = 1.0
#pnice(esp,'esp')
rho0=esp*0.0
rho0[0,0] = 1.0
wf_file = sys.argv[1]
U,V = read_uv(N,wf_file)
Z = read_zc(N,zc_file)
U,V=Zc(Z,U,V)
check_unitarity(U,V)
rho,kappa = rho_kappa(U,V)
gamma,delta = Gamma_Delta(rho,kappa)
print '  t    <N>    <H> '
Nave=F00(rho,Nop)
e0,v1,vpair =H00(rho,kappa,gamma,delta,esp)
e_ave=e0+v1+vpair
e_start=e_ave
r00 = F00(rho,rho0)
ss=' %5.2f %8.5f %8.5f %8.5f' % (0.0,Nave,e_ave,r00)
print ss
u2=U*1.0; v2=V*1.0
for i in range(1,Nt+1) :
  hsp=esp + gamma
  h20 = H20(u2,v2,hsp,delta)
  Z=-dt*h20*1.0j/2
  uh,vh=Zc(Z,u2,v2)
  check_unitarity(u2,v2)
  rho,kappa = rho_kappa(uh,vh)
  gamma,delta = Gamma_Delta(rho,kappa)
  hsp=esp+ gamma
  h20 = H20(uh,vh,hsp,delta)
  Z=-dt*h20*1.0j
  u2,v2=Zc(Z,u2,v2)
  rho,kappa = rho_kappa(u2,v2)
  gamma,delta = Gamma_Delta(rho,kappa)
  e0,v1,vpair = H00(rho,kappa,gamma,delta,esp)
  t=i*dt
  Nave=F00(rho,Nop)
  e_ave=e0+v1+vpair
  r00 = F00(rho,rho0)
  ss=' %6.3f %8.5f %8.5f %9.6f' % (t,Nave,e_ave,r00)
#  if i%10 == 0: print ss
  print ss
